diff --git a/src/command/cmd/registry.rs b/src/command/cmd/registry.rs
index bf726e0..a137f58 100644
--- a/src/command/cmd/registry.rs
+++ b/src/command/cmd/registry.rs
@@ -2,6 +2,27 @@ use crate::model::cell::CellKey;
 use crate::ui::app::AppMode;
 use crate::ui::effect::Panel;
 
+/// Decode a mode-name string (as supplied by `enter-mode`/`edit-or-drill`
+/// keymap bindings) into an `AppMode`.
+fn parse_mode_name(s: &str) -> Result<AppMode, String> {
+    match s {
+        "normal" => Ok(AppMode::Normal),
+        "help" => Ok(AppMode::Help),
+        "formula-panel" => Ok(AppMode::FormulaPanel),
+        "category-panel" => Ok(AppMode::CategoryPanel),
+        "view-panel" => Ok(AppMode::ViewPanel),
+        "tile-select" => Ok(AppMode::TileSelect),
+        "command" => Ok(AppMode::command_mode()),
+        "category-add" => Ok(AppMode::category_add()),
+        "editing" => Ok(AppMode::editing()),
+        "records-normal" => Ok(AppMode::RecordsNormal),
+        "records-editing" => Ok(AppMode::records_editing()),
+        "formula-edit" => Ok(AppMode::formula_edit()),
+        "export-prompt" => Ok(AppMode::export_prompt()),
+        other => Err(format!("Unknown mode: {other}")),
+    }
+}
+
 use super::cell::*;
 use super::commit::*;
 use super::core::*;
@@ -266,22 +287,16 @@ pub fn default_registry() -> CmdRegistry {
     r.register_nullary(|| Box::new(SaveAndQuit));
     r.register_nullary(|| Box::new(SaveCmd));
     r.register_nullary(|| Box::new(EnterSearchMode));
-    r.register(
-        &EnterEditMode {
-            initial_value: String::new(),
-        },
-        |args| {
-            let val = args.first().cloned().unwrap_or_default();
-            Ok(Box::new(EnterEditMode { initial_value: val }))
-        },
-        |_args, ctx| {
-            Ok(Box::new(EnterEditMode {
-                initial_value: ctx.display_value.clone(),
-            }))
-        },
-    );
-    r.register_nullary(|| Box::new(EditOrDrill));
-    r.register_nullary(|| Box::new(EnterEditAtCursorCmd));
+    r.register_pure(&NamedCmd("edit-or-drill"), |args| {
+        require_args("edit-or-drill", args, 1)?;
+        let edit_mode = parse_mode_name(&args[0])?;
+        Ok(Box::new(EditOrDrill { edit_mode }))
+    });
+    r.register_pure(&NamedCmd("enter-edit-at-cursor"), |args| {
+        require_args("enter-edit-at-cursor", args, 1)?;
+        let target_mode = parse_mode_name(&args[0])?;
+        Ok(Box::new(EnterEditAtCursorCmd { target_mode }))
+    });
     r.register_nullary(|| Box::new(EnterExportPrompt));
     r.register_nullary(|| Box::new(EnterFormulaEdit));
     r.register_nullary(|| Box::new(EnterTileSelect));
@@ -310,23 +325,7 @@ pub fn default_registry() -> CmdRegistry {
     );
     r.register_pure(&NamedCmd("enter-mode"), |args| {
         require_args("enter-mode", args, 1)?;
-        let mode = match args[0].as_str() {
-            "normal" => AppMode::Normal,
-            "help" => AppMode::Help,
-            "formula-panel" => AppMode::FormulaPanel,
-            "category-panel" => AppMode::CategoryPanel,
-            "view-panel" => AppMode::ViewPanel,
-            "tile-select" => AppMode::TileSelect,
-            "command" => AppMode::command_mode(),
-            "category-add" => AppMode::category_add(),
-            "editing" => AppMode::editing(),
-            "records-normal" => AppMode::RecordsNormal,
-            "records-editing" => AppMode::records_editing(),
-            "formula-edit" => AppMode::formula_edit(),
-            "export-prompt" => AppMode::export_prompt(),
-            other => return Err(format!("Unknown mode: {other}")),
-        };
-        Ok(Box::new(EnterMode(mode)))
+        Ok(Box::new(EnterMode(parse_mode_name(&args[0])?)))
     });
 
     // ── Search ───────────────────────────────────────────────────────────
@@ -522,25 +521,33 @@ pub fn default_registry() -> CmdRegistry {
     r.register_nullary(|| Box::new(CommandModeBackspace));
 
     // ── Commit ───────────────────────────────────────────────────────────
+    // commit-cell-edit / commit-and-advance-right take a mode-name arg
+    // (e.g. "editing" or "records-editing") as args[0]. The keymap supplies
+    // it; the command never inspects ctx.mode.
     r.register(
         &CommitAndAdvance {
             key: CellKey::new(vec![]),
             value: String::new(),
             advance: AdvanceDir::Down,
             cursor: CursorState::default(),
+            edit_mode: AppMode::editing(),
         },
         |args| {
-            if args.len() < 2 {
-                return Err("commit-cell-edit requires a value and coords".into());
+            if args.len() < 3 {
+                return Err("commit-cell-edit requires a mode, value, and coords".into());
             }
+            let edit_mode = parse_mode_name(&args[0])?;
             Ok(Box::new(CommitAndAdvance {
-                key: parse_cell_key_from_args(&args[1..]),
-                value: args[0].clone(),
+                key: parse_cell_key_from_args(&args[2..]),
+                value: args[1].clone(),
                 advance: AdvanceDir::Down,
                 cursor: CursorState::default(),
+                edit_mode,
             }))
         },
-        |_args, ctx| {
+        |args, ctx| {
+            require_args("commit-cell-edit", args, 1)?;
+            let edit_mode = parse_mode_name(&args[0])?;
             let value = read_buffer(ctx, "edit");
             let key = ctx.cell_key().clone().ok_or("no cell at cursor")?;
             Ok(Box::new(CommitAndAdvance {
@@ -548,6 +555,7 @@ pub fn default_registry() -> CmdRegistry {
                 value,
                 advance: AdvanceDir::Down,
                 cursor: CursorState::from_ctx(ctx),
+                edit_mode,
             }))
         },
     );
@@ -557,9 +565,12 @@ pub fn default_registry() -> CmdRegistry {
             value: String::new(),
             advance: AdvanceDir::Right,
             cursor: CursorState::default(),
+            edit_mode: AppMode::editing(),
         },
         |_| Err("commit-and-advance-right requires context".into()),
-        |_args, ctx| {
+        |args, ctx| {
+            require_args("commit-and-advance-right", args, 1)?;
+            let edit_mode = parse_mode_name(&args[0])?;
             let value = read_buffer(ctx, "edit");
             let key = ctx.cell_key().clone().ok_or("no cell at cursor")?;
             Ok(Box::new(CommitAndAdvance {
@@ -567,6 +578,7 @@ pub fn default_registry() -> CmdRegistry {
                 value,
                 advance: AdvanceDir::Right,
                 cursor: CursorState::from_ctx(ctx),
+                edit_mode,
             }))
         },
     );
diff --git a/src/command/keymap.rs b/src/command/keymap.rs
index a0276e3..92d5870 100644
--- a/src/command/keymap.rs
+++ b/src/command/keymap.rs
@@ -431,9 +431,21 @@ impl KeymapSet {
         );
         normal.bind(KeyCode::Tab, none, "cycle-panel-focus");
 
-        // Editing entry — i/a drill into aggregated cells, else edit
-        normal.bind(KeyCode::Char('i'), none, "edit-or-drill");
-        normal.bind(KeyCode::Char('a'), none, "edit-or-drill");
+        // Editing entry — i/a drill into aggregated cells, else edit.
+        // The mode arg controls which editing mode is entered; records-normal
+        // overrides these to "records-editing" via its own bindings.
+        normal.bind_args(
+            KeyCode::Char('i'),
+            none,
+            "edit-or-drill",
+            vec!["editing".into()],
+        );
+        normal.bind_args(
+            KeyCode::Char('a'),
+            none,
+            "edit-or-drill",
+            vec!["editing".into()],
+        );
         normal.bind(KeyCode::Enter, none, "enter-advance");
         normal.bind(KeyCode::Char('e'), ctrl, "enter-export-prompt");
 
@@ -488,10 +500,27 @@ impl KeymapSet {
 
         // ── Records normal mode (inherits from normal) ────────────────────
         let mut rn = Keymap::with_parent(normal);
+        // Override i/a so the edit branch produces records-editing mode
+        // instead of inheriting the normal-mode "editing" arg.
+        rn.bind_args(
+            KeyCode::Char('i'),
+            none,
+            "edit-or-drill",
+            vec!["records-editing".into()],
+        );
+        rn.bind_args(
+            KeyCode::Char('a'),
+            none,
+            "edit-or-drill",
+            vec!["records-editing".into()],
+        );
         rn.bind_seq(
             KeyCode::Char('o'),
             none,
-            vec![("add-record-row", vec![]), ("enter-edit-at-cursor", vec![])],
+            vec![
+                ("add-record-row", vec![]),
+                ("enter-edit-at-cursor", vec!["records-editing".into()]),
+            ],
         );
         set.insert(ModeKey::RecordsNormal, Arc::new(rn));
 
@@ -736,6 +765,8 @@ impl KeymapSet {
         set.insert(ModeKey::TileSelect, Arc::new(ts));
 
         // ── Editing mode ─────────────────────────────────────────────────
+        // commit-* takes the target edit-mode arg so the command stays
+        // mode-agnostic; records-editing overrides Enter/Tab below.
         let mut ed = Keymap::new();
         ed.bind_seq(
             KeyCode::Esc,
@@ -749,7 +780,7 @@ impl KeymapSet {
             KeyCode::Enter,
             none,
             vec![
-                ("commit-cell-edit", vec![]),
+                ("commit-cell-edit", vec!["editing".into()]),
                 ("clear-buffer", vec!["edit".into()]),
             ],
         );
@@ -757,7 +788,7 @@ impl KeymapSet {
             KeyCode::Tab,
             none,
             vec![
-                ("commit-and-advance-right", vec![]),
+                ("commit-and-advance-right", vec!["editing".into()]),
                 ("clear-buffer", vec!["edit".into()]),
             ],
         );
@@ -767,6 +798,7 @@ impl KeymapSet {
         set.insert(ModeKey::Editing, ed.clone());
 
         // ── Records editing mode (inherits from editing) ──────────────────
+        // Override Enter/Tab so the post-commit re-enter targets records-editing.
         let mut re = Keymap::with_parent(ed);
         re.bind_seq(
             KeyCode::Esc,
@@ -776,6 +808,22 @@ impl KeymapSet {
                 ("enter-mode", vec!["records-normal".into()]),
             ],
         );
+        re.bind_seq(
+            KeyCode::Enter,
+            none,
+            vec![
+                ("commit-cell-edit", vec!["records-editing".into()]),
+                ("clear-buffer", vec!["edit".into()]),
+            ],
+        );
+        re.bind_seq(
+            KeyCode::Tab,
+            none,
+            vec![
+                ("commit-and-advance-right", vec!["records-editing".into()]),
+                ("clear-buffer", vec!["edit".into()]),
+            ],
+        );
         set.insert(ModeKey::RecordsEditing, Arc::new(re));
 
         // ── Formula edit ─────────────────────────────────────────────────
diff --git a/src/ui/effect.rs b/src/ui/effect.rs
index eb40c9d..16ae172 100644
--- a/src/ui/effect.rs
+++ b/src/ui/effect.rs
@@ -124,10 +124,19 @@ impl Effect for RemoveFormula {
 
 /// Re-enter edit mode by reading the cell value at the current cursor.
 /// Used after commit+advance to continue data entry.
+///
+/// `target_mode` is supplied by the caller (keymap binding via
+/// `EnterEditAtCursorCmd`, or `CommitAndAdvance` from its own `edit_mode`
+/// field). The effect itself never inspects `app.mode` — the mode is decided
+/// statically by whoever invoked us.
 #[derive(Debug)]
-pub struct EnterEditAtCursor;
+pub struct EnterEditAtCursor {
+    pub target_mode: AppMode,
+}
 impl Effect for EnterEditAtCursor {
     fn apply(&self, app: &mut App) {
+        // Layout may be stale relative to prior effects in this batch (e.g.
+        // AddRecordRow added a row); rebuild before reading display_value.
         app.rebuild_layout();
         let ctx = app.cmd_context(
             crossterm::event::KeyCode::Null,
@@ -136,11 +145,7 @@ impl Effect for EnterEditAtCursor {
         let value = ctx.display_value.clone();
         drop(ctx);
         app.buffers.insert("edit".to_string(), value);
-        app.mode = if app.mode.is_records() {
-            AppMode::records_editing()
-        } else {
-            AppMode::editing()
-        };
+        app.mode = self.target_mode.clone();
     }
 }
 
@@ -1288,6 +1293,41 @@ mod tests {
         assert_eq!(app.mode, AppMode::Help);
     }
 
+    /// `EnterEditAtCursor` must use its `target_mode` field, *not* whatever
+    /// `app.mode` happens to be when applied. Previous implementation
+    /// branched on `app.mode.is_records()` — the parameterized version
+    /// trusts the caller (keymap or composing command).
+    #[test]
+    fn enter_edit_at_cursor_uses_target_mode_not_app_mode() {
+        let mut app = test_app();
+        // App starts in Normal mode — but caller has decided we want
+        // RecordsEditing (e.g. records-mode `o` sequence).
+        assert_eq!(app.mode, AppMode::Normal);
+        EnterEditAtCursor {
+            target_mode: AppMode::records_editing(),
+        }
+        .apply(&mut app);
+        assert!(
+            matches!(app.mode, AppMode::RecordsEditing { .. }),
+            "Expected RecordsEditing, got {:?}",
+            app.mode
+        );
+
+        // Same effect with editing target — should land in plain Editing
+        // even if app.mode was something else.
+        let mut app2 = test_app();
+        app2.mode = AppMode::RecordsNormal;
+        EnterEditAtCursor {
+            target_mode: AppMode::editing(),
+        }
+        .apply(&mut app2);
+        assert!(
+            matches!(app2.mode, AppMode::Editing { .. }),
+            "Expected Editing, got {:?}",
+            app2.mode
+        );
+    }
+
     /// SetBuffer with empty value clears the buffer (used by clear-buffer command
     /// in keymap sequences after commit).
     #[test]
